<?
// $Id: class.UsenetIndexer.php,v 1.1 2000/11/12 01:54:59 xi Exp $

/******************************************************************************
*    Usenet Indexer - A nice and fast usenet indexer
*    Copyright (C) 2000  Christian Laursen <xi@borderworlds.dk>
*
*    This program is free software; you can redistribute it and/or modify
*    it under the terms of the GNU General Public License as published by
*    the Free Software Foundation; either version 2 of the License, or
*    (at your option) any later version.
*
*    This program is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*    GNU General Public License for more details.
*
*    You should have received a copy of the GNU General Public License
*    along with this program; if not, write to the Free Software
*    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
******************************************************************************/

class UsenetIndexer {
  var $backend;

  function UsenetIndexer ($backend) {
    $this->backend = $backend;
  }

  function search ($string, $groups, $maxage = 0, $offset = 0) {
    $results = array();

    $url = "http://".$this->backend."/bsearch.html?search=".rawurlencode($string)."&maxage=".intval($maxage)."&offset=".intval($offset);
    while (list($dummy,$group) = each ($groups)) {
      $url .= "&groups=".rawurlencode($group);
    }    
    $fd = fopen ($url, "r") or die("Couldn't connect to backend server");
    $buffer = chop(fgets($fd, 4096));
    if (ereg('^Results: ([0-9]+)$', $buffer, $regs)) {
      $results[results] = $regs[1];
    } else echo $buffer;
    $buffer = chop(fgets($fd, 4096));
    if (ereg('^Searchtime: (.+)$', $buffer, $regs)) {
      $results[searchtime] = $regs[1];
    }
    $continue = 1;
    $i = 0;
    while ($continue) {
      $res = array();
      $buffer = chop(fgets($fd, 4096));
      if (ereg('^Id: ([0-9]+)$', $buffer, $regs)) {
	$res[id] = $regs[1];

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^From: (.+)$', $buffer, $regs)) {
	  $res[from] = $regs[1];
	}

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^Subject: (.+)$', $buffer, $regs)) {
	  $res[subject] = $regs[1];
	}

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^Score: ([0-9]+)$', $buffer, $regs)) {
	  $res[score] = $regs[1];
	}
	$results[$i++] = $res;
      } else {
	$continue = 0;
      }
    }
    fclose($fd);
    
    return $results;
  }

  function getmsg ($id) {
    $url = "http://".$this->backend."/bshow.html?id=".intval($id);

    $fd = fopen ($url, "r") or die("Couldn't connect to backend server");
    $msg = array();
    do {
	$buffer = chop(fgets($fd, 4096));
	if ($buffer != '') {
	  if (ereg('^([^:]+): (.+)$', $buffer, $regs)) {
	    $msg[$regs[1]] = $regs[2];
	  }	  
	}
    } while ($buffer != '');
    $body = '';
    while (!feof($fd)) {
      $body .= fgets($fd, 4096);
    }
    fclose($fd);
    $msg[body] = $body;
    return $msg;
  }

  function getthread ($id) {
    $url = "http://".$this->backend."/bthread.html?id=".intval($id);

    $fd = fopen ($url, "r") or die("Couldn't connect to backend server");
    $thread = array();
    $continue = 1;
    $i = 0;
    while ($continue) {
      $res = array();
      $buffer = chop(fgets($fd, 4096));
      if (ereg('^Id: ([0-9]+)$', $buffer, $regs)) {
	$res[id] = $regs[1];

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^From: (.+)$', $buffer, $regs)) {
	  $res[from] = $regs[1];
	}

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^Subject: (.+)$', $buffer, $regs)) {
	  $res[subject] = $regs[1];
	}

	$buffer = chop(fgets($fd, 4096));
	if (ereg('^Level: ([0-9]+)$', $buffer, $regs)) {
	  $res[level] = $regs[1];
	}
	$thread[$i++] = $res;
      } else {
	$continue = 0;
      }
    }


    fclose($fd);

    return $thread;
  }
}
?>
